'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = prefixReducer;

var _lodash = require('lodash.mapkeys');

var _lodash2 = _interopRequireDefault(_lodash);

var _createReducer = require('./createReducer');

var _createReducer2 = _interopRequireDefault(_createReducer);

var _addCreationStack = require('./addCreationStack');

var _addCreationStack2 = _interopRequireDefault(_addCreationStack);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function prefixReducer(prefix) {
  return function (reducer) {
    if (reducer.actionHandlers instanceof Object) {
      return (0, _createReducer2.default)(reducer.initialState, (0, _lodash2.default)(reducer.actionHandlers, function (handler, key) {
        return prefix + key;
      }));
    }
    var result = function result(state, action) {
      return typeof action.type === 'string' && action.type.startsWith(prefix) ? reducer(state, (0, _extends3.default)({}, action, { type: action.type.substring(prefix.length) })) : state;
    };

    if (process.env.NODE_ENV !== 'production') result = (0, _addCreationStack2.default)(result, 'reducer');
    return result;
  };
}